using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CallCenterApi.DB;
using System.Data;
using System.Data.SqlClient;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_SMS_SendSMSTask
    /// </summary>
    public partial class T_SMS_SendSMSTask
    {
        public T_SMS_SendSMSTask()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int SMSID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_SMS_SendSMSTask");
            strSql.Append(" where SMSID=@SMSID");
            SqlParameter[] parameters = {
					new SqlParameter("@SMSID", SqlDbType.Int,4)
			};
            parameters[0].Value = SMSID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_SMS_SendSMSTask model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_SMS_SendSMSTask(");
            strSql.Append("TelNum,Content,CommitTime,State,SendTime,LastSentTime,CurSentCount,MaxSendCount,Info,F_UserID,F_CustomerID,F_Name)");
            strSql.Append(" values (");
            strSql.Append("@TelNum,@Content,@CommitTime,@State,@SendTime,@LastSentTime,@CurSentCount,@MaxSendCount,@Info,@F_UserID,@F_CustomerID,@F_Name)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@TelNum", SqlDbType.VarChar,20),
					new SqlParameter("@Content", SqlDbType.NVarChar,100),
					new SqlParameter("@CommitTime", SqlDbType.DateTime),
					new SqlParameter("@State", SqlDbType.Int,4),
					new SqlParameter("@SendTime", SqlDbType.DateTime),
					new SqlParameter("@LastSentTime", SqlDbType.DateTime),
					new SqlParameter("@CurSentCount", SqlDbType.Int,4),
					new SqlParameter("@MaxSendCount", SqlDbType.Int,4),
					new SqlParameter("@Info", SqlDbType.NVarChar,50),
					new SqlParameter("@F_UserID", SqlDbType.Int,4),
					new SqlParameter("@F_CustomerID", SqlDbType.Int,4),
					new SqlParameter("@F_Name", SqlDbType.NVarChar,50)};
            parameters[0].Value = model.TelNum;
            parameters[1].Value = model.Content;
            parameters[2].Value = model.CommitTime;
            parameters[3].Value = model.State;
            parameters[4].Value = model.SendTime;
            parameters[5].Value = model.LastSentTime;
            parameters[6].Value = model.CurSentCount;
            parameters[7].Value = model.MaxSendCount;
            parameters[8].Value = model.Info;
            parameters[9].Value = model.F_UserID;
            parameters[10].Value = model.F_CustomerID;
            parameters[11].Value = model.F_Name;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_SMS_SendSMSTask model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_SMS_SendSMSTask set ");
            strSql.Append("TelNum=@TelNum,");
            strSql.Append("Content=@Content,");
            strSql.Append("CommitTime=@CommitTime,");
            strSql.Append("State=@State,");
            strSql.Append("SendTime=@SendTime,");
            strSql.Append("LastSentTime=@LastSentTime,");
            strSql.Append("CurSentCount=@CurSentCount,");
            strSql.Append("MaxSendCount=@MaxSendCount,");
            strSql.Append("Info=@Info,");
            strSql.Append("F_UserID=@F_UserID,");
            strSql.Append("F_CustomerID=@F_CustomerID,");
            strSql.Append("F_Name=@F_Name");
            strSql.Append(" where SMSID=@SMSID");
            SqlParameter[] parameters = {
					new SqlParameter("@TelNum", SqlDbType.VarChar,20),
					new SqlParameter("@Content", SqlDbType.NVarChar,100),
					new SqlParameter("@CommitTime", SqlDbType.DateTime),
					new SqlParameter("@State", SqlDbType.Int,4),
					new SqlParameter("@SendTime", SqlDbType.DateTime),
					new SqlParameter("@LastSentTime", SqlDbType.DateTime),
					new SqlParameter("@CurSentCount", SqlDbType.Int,4),
					new SqlParameter("@MaxSendCount", SqlDbType.Int,4),
					new SqlParameter("@Info", SqlDbType.NVarChar,50),
					new SqlParameter("@F_UserID", SqlDbType.Int,4),
					new SqlParameter("@F_CustomerID", SqlDbType.Int,4),
					new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
					new SqlParameter("@SMSID", SqlDbType.Int,4)};
            parameters[0].Value = model.TelNum;
            parameters[1].Value = model.Content;
            parameters[2].Value = model.CommitTime;
            parameters[3].Value = model.State;
            parameters[4].Value = model.SendTime;
            parameters[5].Value = model.LastSentTime;
            parameters[6].Value = model.CurSentCount;
            parameters[7].Value = model.MaxSendCount;
            parameters[8].Value = model.Info;
            parameters[9].Value = model.F_UserID;
            parameters[10].Value = model.F_CustomerID;
            parameters[11].Value = model.F_Name;
            parameters[12].Value = model.SMSID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int SMSID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_SendSMSTask ");
            strSql.Append(" where SMSID=@SMSID");
            SqlParameter[] parameters = {
					new SqlParameter("@SMSID", SqlDbType.Int,4)
			};
            parameters[0].Value = SMSID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string SMSIDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_SendSMSTask ");
            strSql.Append(" where SMSID in (" + SMSIDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_SMS_SendSMSTask GetModel(int SMSID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 SMSID,TelNum,Content,CommitTime,State,SendTime,LastSentTime,CurSentCount,MaxSendCount,Info,F_UserID,F_CustomerID,F_Name from T_SMS_SendSMSTask ");
            strSql.Append(" where SMSID=@SMSID");
            SqlParameter[] parameters = {
					new SqlParameter("@SMSID", SqlDbType.Int,4)
			};
            parameters[0].Value = SMSID;

            CallCenterApi.Model.T_SMS_SendSMSTask model = new CallCenterApi.Model.T_SMS_SendSMSTask();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["SMSID"] != null && ds.Tables[0].Rows[0]["SMSID"].ToString() != "")
                {
                    model.SMSID = int.Parse(ds.Tables[0].Rows[0]["SMSID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["TelNum"] != null && ds.Tables[0].Rows[0]["TelNum"].ToString() != "")
                {
                    model.TelNum = ds.Tables[0].Rows[0]["TelNum"].ToString();
                }
                if (ds.Tables[0].Rows[0]["Content"] != null && ds.Tables[0].Rows[0]["Content"].ToString() != "")
                {
                    model.Content = ds.Tables[0].Rows[0]["Content"].ToString();
                }
                if (ds.Tables[0].Rows[0]["CommitTime"] != null && ds.Tables[0].Rows[0]["CommitTime"].ToString() != "")
                {
                    model.CommitTime = DateTime.Parse(ds.Tables[0].Rows[0]["CommitTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["State"] != null && ds.Tables[0].Rows[0]["State"].ToString() != "")
                {
                    model.State = int.Parse(ds.Tables[0].Rows[0]["State"].ToString());
                }
                if (ds.Tables[0].Rows[0]["SendTime"] != null && ds.Tables[0].Rows[0]["SendTime"].ToString() != "")
                {
                    model.SendTime = DateTime.Parse(ds.Tables[0].Rows[0]["SendTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["LastSentTime"] != null && ds.Tables[0].Rows[0]["LastSentTime"].ToString() != "")
                {
                    model.LastSentTime = DateTime.Parse(ds.Tables[0].Rows[0]["LastSentTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["CurSentCount"] != null && ds.Tables[0].Rows[0]["CurSentCount"].ToString() != "")
                {
                    model.CurSentCount = int.Parse(ds.Tables[0].Rows[0]["CurSentCount"].ToString());
                }
                if (ds.Tables[0].Rows[0]["MaxSendCount"] != null && ds.Tables[0].Rows[0]["MaxSendCount"].ToString() != "")
                {
                    model.MaxSendCount = int.Parse(ds.Tables[0].Rows[0]["MaxSendCount"].ToString());
                }
                if (ds.Tables[0].Rows[0]["Info"] != null && ds.Tables[0].Rows[0]["Info"].ToString() != "")
                {
                    model.Info = ds.Tables[0].Rows[0]["Info"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_UserID"] != null && ds.Tables[0].Rows[0]["F_UserID"].ToString() != "")
                {
                    model.F_UserID = int.Parse(ds.Tables[0].Rows[0]["F_UserID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CustomerID"] != null && ds.Tables[0].Rows[0]["F_CustomerID"].ToString() != "")
                {
                    model.F_CustomerID = int.Parse(ds.Tables[0].Rows[0]["F_CustomerID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Name"] != null && ds.Tables[0].Rows[0]["F_Name"].ToString() != "")
                {
                    model.F_Name = ds.Tables[0].Rows[0]["F_Name"].ToString();
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select SMSID,TelNum,Content,CommitTime,State,SendTime,LastSentTime,CurSentCount,MaxSendCount,Info,F_UserID,F_CustomerID,F_Name ");
            strSql.Append(" FROM T_SMS_SendSMSTask ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" SMSID,TelNum,Content,CommitTime,State,SendTime,LastSentTime,CurSentCount,MaxSendCount,Info,F_UserID,F_CustomerID,F_Name ");
            strSql.Append(" FROM T_SMS_SendSMSTask ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_SMS_SendSMSTask ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.SMSID desc");
            }
            strSql.Append(")AS Row, T.*  from T_SMS_SendSMSTask T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_SMS_SendSMSTask";
            parameters[1].Value = "SMSID";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}
